﻿using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Drawing;
using System.Diagnostics;
using System.Windows.Forms;
//Author: Troy Simpson - VMDiskSize - VMWare Disk Size Changer (wrapper)
//Copyright (C) 2005  Troy Simpson
//For more information, see http://www.ebswift.com
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

using Proc;
using System.IO;
namespace VMDiskSize
{
	// Created by SharpDevelop.
	// User: simpsont
	// Date: 11/11/2005
	// Time: 9:13 AM
	// 
	// To change this template use Tools | Options | Coding | Edit Standard Headers.
	//
	public class MainForm : System.Windows.Forms.Form
	{

		private ProcessCaller processCaller;

		public MainForm()
		{
			//
			// The Me.InitializeComponent call is required for Windows Forms designer support.
			//
			this.InitializeComponent();
			//
			// TODO : Add constructor code after InitializeComponents
			//
			this.Closing += Me_OnClosing;
		}

		#region " Windows Forms Designer generated code "
// This method is required for Windows Forms designer support.
// Do not change the method contents inside the source code editor. The Forms designer might
// not be able to load this method if it was changed manually.
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.ctxWhatsThis = new System.Windows.Forms.ContextMenuStrip(this.components);
			this.whatsThisToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
			this.btnChangeSize = new System.Windows.Forms.Button();
			this.lblDest = new System.Windows.Forms.Label();
			this.btnSelectDest = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.linkLabel1 = new System.Windows.Forms.LinkLabel();
			this.tabControl1 = new System.Windows.Forms.TabControl();
			this.tabPage1 = new System.Windows.Forms.TabPage();
			this.txtNewSize = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.txtOutput = new System.Windows.Forms.TextBox();
			this.btnExit = new System.Windows.Forms.Button();
			this.statusStrip1 = new System.Windows.Forms.StatusStrip();
			this.StatusLabel1 = new System.Windows.Forms.ToolStripStatusLabel();
			this.ProgressBar1 = new System.Windows.Forms.ToolStripProgressBar();
			this.helpProvider1 = new System.Windows.Forms.HelpProvider();
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.ctxWhatsThis.SuspendLayout();
			this.tabControl1.SuspendLayout();
			this.tabPage1.SuspendLayout();
			this.statusStrip1.SuspendLayout();
			this.SuspendLayout();
			//
			//ctxWhatsThis
			//
			this.ctxWhatsThis.Items.AddRange(new System.Windows.Forms.ToolStripItem[] { this.whatsThisToolStripMenuItem });
			this.ctxWhatsThis.Name = "ctxWhatsThis";
			this.helpProvider1.SetShowHelp(this.ctxWhatsThis, false);
			this.ctxWhatsThis.Size = new System.Drawing.Size(146, 26);
			this.ctxWhatsThis.Text = "What's This?";
			//
			//whatsThisToolStripMenuItem
			//
			this.whatsThisToolStripMenuItem.Name = "whatsThisToolStripMenuItem";
			this.whatsThisToolStripMenuItem.Size = new System.Drawing.Size(145, 22);
			this.whatsThisToolStripMenuItem.Text = "What's This?";
			//
			//btnChangeSize
			//
			this.btnChangeSize.Enabled = false;
			this.btnChangeSize.Location = new System.Drawing.Point(0, 225);
			this.btnChangeSize.Name = "btnChangeSize";
			this.btnChangeSize.Size = new System.Drawing.Size(96, 23);
			this.btnChangeSize.TabIndex = 2;
			this.btnChangeSize.Text = "Change Size";
			this.btnChangeSize.UseCompatibleTextRendering = true;
			this.btnChangeSize.UseVisualStyleBackColor = true;
			this.btnChangeSize.Click += this.BtnChangeSizeClick;
			//
			//lblDest
			//
			this.lblDest.AllowDrop = true;
			this.lblDest.AutoEllipsis = true;
			this.lblDest.BackColor = System.Drawing.Color.Transparent;
			this.lblDest.Location = new System.Drawing.Point(36, 9);
			this.lblDest.Name = "lblDest";
			this.lblDest.Size = new System.Drawing.Size(261, 52);
			this.lblDest.TabIndex = 3;
			this.lblDest.Text = "Select the VMWare Virtual Disk Drive";
			this.lblDest.UseCompatibleTextRendering = true;
			//
			//btnSelectDest
			//
			this.helpProvider1.SetHelpString(this.btnSelectDest, "The new ISO file to output.");
			this.btnSelectDest.Location = new System.Drawing.Point(3, 6);
			this.btnSelectDest.Name = "btnSelectDest";
			this.helpProvider1.SetShowHelp(this.btnSelectDest, true);
			this.btnSelectDest.Size = new System.Drawing.Size(27, 23);
			this.btnSelectDest.TabIndex = 4;
			this.btnSelectDest.Text = "...";
			this.btnSelectDest.UseCompatibleTextRendering = true;
			this.btnSelectDest.UseVisualStyleBackColor = true;
			//
			//btnCancel
			//
			this.btnCancel.Enabled = false;
			this.btnCancel.Location = new System.Drawing.Point(129, 225);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.Size = new System.Drawing.Size(75, 23);
			this.btnCancel.TabIndex = 6;
			this.btnCancel.Text = "Cancel";
			this.btnCancel.UseCompatibleTextRendering = true;
			this.btnCancel.UseVisualStyleBackColor = true;
			//
			//label1
			//
			this.label1.Location = new System.Drawing.Point(109, 286);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(183, 23);
			this.label1.TabIndex = 7;
			this.label1.Text = "Copyright © Troy Simpson 2005";
			this.label1.UseCompatibleTextRendering = true;
			//
			//linkLabel1
			//
			this.linkLabel1.Location = new System.Drawing.Point(288, 286);
			this.linkLabel1.Name = "linkLabel1";
			this.linkLabel1.Size = new System.Drawing.Size(148, 23);
			this.linkLabel1.TabIndex = 8;
			this.linkLabel1.TabStop = true;
			this.linkLabel1.Text = "http://www.ebswift.com";
			this.linkLabel1.UseCompatibleTextRendering = true;
			this.linkLabel1.LinkClicked += this.LinkLabel1LinkClicked;
			//
			//tabControl1
			//
			this.tabControl1.Controls.Add(this.tabPage1);
			this.tabControl1.Location = new System.Drawing.Point(3, 3);
			this.tabControl1.Name = "tabControl1";
			this.tabControl1.SelectedIndex = 0;
			this.tabControl1.Size = new System.Drawing.Size(689, 280);
			this.tabControl1.TabIndex = 9;
			//
			//tabPage1
			//
			this.tabPage1.BackColor = System.Drawing.SystemColors.ControlLightLight;
			this.tabPage1.Controls.Add(this.txtNewSize);
			this.tabPage1.Controls.Add(this.label2);
			this.tabPage1.Controls.Add(this.txtOutput);
			this.tabPage1.Controls.Add(this.lblDest);
			this.tabPage1.Controls.Add(this.btnCancel);
			this.tabPage1.Controls.Add(this.btnSelectDest);
			this.tabPage1.Controls.Add(this.btnChangeSize);
			this.tabPage1.Location = new System.Drawing.Point(4, 22);
			this.tabPage1.Name = "tabPage1";
			this.tabPage1.Padding = new System.Windows.Forms.Padding(3);
			this.tabPage1.Size = new System.Drawing.Size(681, 254);
			this.tabPage1.TabIndex = 0;
			this.tabPage1.Text = "Change VMWare Disk Size";
			this.tabPage1.UseVisualStyleBackColor = true;
			//
			//txtNewSize
			//
			this.txtNewSize.Location = new System.Drawing.Point(92, 94);
			this.txtNewSize.Name = "txtNewSize";
			this.txtNewSize.Size = new System.Drawing.Size(85, 21);
			this.txtNewSize.TabIndex = 9;
			//
			//label2
			//
			this.label2.BackColor = System.Drawing.Color.Transparent;
			this.label2.Location = new System.Drawing.Point(6, 94);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(100, 23);
			this.label2.TabIndex = 8;
			this.label2.Text = "New Size (GB):";
			this.label2.UseCompatibleTextRendering = true;
			//
			//txtOutput
			//
			this.txtOutput.Location = new System.Drawing.Point(321, 6);
			this.txtOutput.Multiline = true;
			this.txtOutput.Name = "txtOutput";
			this.txtOutput.ReadOnly = true;
			this.txtOutput.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.txtOutput.Size = new System.Drawing.Size(354, 242);
			this.txtOutput.TabIndex = 7;
			this.txtOutput.Text = "VMDiskSize Alpha 1.0.0\n\r\n\rCopyright © Troy Simpson 2005\n\rhttp://www.ebswift.com\n\r\n\rLicensed under the GPL\n\r\n\rContains code from Mike Mayer";
			//
			//btnExit
			//
			this.btnExit.Location = new System.Drawing.Point(3, 281);
			this.btnExit.Name = "btnExit";
			this.btnExit.Size = new System.Drawing.Size(75, 23);
			this.btnExit.TabIndex = 10;
			this.btnExit.Text = "Exit";
			this.btnExit.UseCompatibleTextRendering = true;
			this.btnExit.UseVisualStyleBackColor = true;
			//
			//statusStrip1
			//
			this.statusStrip1.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
				this.StatusLabel1,
				this.ProgressBar1
			});
			this.statusStrip1.Location = new System.Drawing.Point(0, 309);
			this.statusStrip1.Name = "statusStrip1";
			this.statusStrip1.Size = new System.Drawing.Size(693, 22);
			this.statusStrip1.SizingGrip = false;
			this.statusStrip1.TabIndex = 11;
			this.statusStrip1.Text = "statusStrip1";
			//
			//StatusLabel1
			//
			this.StatusLabel1.Name = "StatusLabel1";
			this.StatusLabel1.Size = new System.Drawing.Size(162, 17);
			this.StatusLabel1.Text = "Awaiting Source and Destination";
			//
			//ProgressBar1
			//
			this.ProgressBar1.Name = "ProgressBar1";
			this.ProgressBar1.Size = new System.Drawing.Size(100, 16);
			this.ProgressBar1.Visible = false;
			//
			//openFileDialog1
			//
			this.openFileDialog1.DefaultExt = "vmdx";
			this.openFileDialog1.Filter = "VMWare Disk Images|*.vmdk";
			//
			//MainForm
			//
			this.AutoScaleDimensions = new System.Drawing.SizeF(6f, 13f);
			this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
			this.ClientSize = new System.Drawing.Size(693, 331);
			this.Controls.Add(this.statusStrip1);
			this.Controls.Add(this.btnExit);
			this.Controls.Add(this.tabControl1);
			this.Controls.Add(this.linkLabel1);
			this.Controls.Add(this.label1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.HelpButton = true;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "MainForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Change VMWare Disk Size";
			this.ctxWhatsThis.ResumeLayout(false);
			this.tabControl1.ResumeLayout(false);
			this.tabPage1.ResumeLayout(false);
			this.tabPage1.PerformLayout();
			this.statusStrip1.ResumeLayout(false);
			this.statusStrip1.PerformLayout();
			this.ResumeLayout(false);
			this.PerformLayout();
		}
		private System.Windows.Forms.ToolStripProgressBar ProgressBar1;
		private System.Windows.Forms.TextBox withEventsField_txtNewSize;
		private System.Windows.Forms.TextBox txtNewSize {
			get { return withEventsField_txtNewSize; }
			set {
				if (withEventsField_txtNewSize != null) {
					withEventsField_txtNewSize.TextChanged -= txtNewSizeTextChanged;
				}
				withEventsField_txtNewSize = value;
				if (withEventsField_txtNewSize != null) {
					withEventsField_txtNewSize.TextChanged += txtNewSizeTextChanged;
				}
			}
		}
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		private System.Windows.Forms.TextBox txtOutput;
		private System.Windows.Forms.ToolStripMenuItem whatsThisToolStripMenuItem;
		private System.Windows.Forms.ContextMenuStrip ctxWhatsThis;
		private System.Windows.Forms.ToolStripMenuItem ContextMenuStrip;
		private System.Windows.Forms.HelpProvider helpProvider1;
		private System.Windows.Forms.ToolStripStatusLabel StatusLabel1;
		private System.Windows.Forms.StatusStrip statusStrip1;
		private System.Windows.Forms.Button withEventsField_btnExit;
		private System.Windows.Forms.Button btnExit {
			get { return withEventsField_btnExit; }
			set {
				if (withEventsField_btnExit != null) {
					withEventsField_btnExit.Click -= BtnExitClick;
				}
				withEventsField_btnExit = value;
				if (withEventsField_btnExit != null) {
					withEventsField_btnExit.Click += BtnExitClick;
				}
			}
		}
		private System.Windows.Forms.TabPage tabPage1;
		private System.Windows.Forms.TabControl tabControl1;
		private System.Windows.Forms.LinkLabel linkLabel1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button withEventsField_btnCancel;
		private System.Windows.Forms.Button btnCancel {
			get { return withEventsField_btnCancel; }
			set {
				if (withEventsField_btnCancel != null) {
					withEventsField_btnCancel.Click -= BtnCancelClick;
				}
				withEventsField_btnCancel = value;
				if (withEventsField_btnCancel != null) {
					withEventsField_btnCancel.Click += BtnCancelClick;
				}
			}
		}
		private System.Windows.Forms.Button withEventsField_btnSelectDest;
		private System.Windows.Forms.Button btnSelectDest {
			get { return withEventsField_btnSelectDest; }
			set {
				if (withEventsField_btnSelectDest != null) {
					withEventsField_btnSelectDest.Click -= BtnSelectDestClick;
				}
				withEventsField_btnSelectDest = value;
				if (withEventsField_btnSelectDest != null) {
					withEventsField_btnSelectDest.Click += BtnSelectDestClick;
				}
			}
		}
		private System.Windows.Forms.Label withEventsField_lblDest;
		private System.Windows.Forms.Label lblDest {
			get { return withEventsField_lblDest; }
			set {
				if (withEventsField_lblDest != null) {
					withEventsField_lblDest.DragDrop -= lblDestDrop;
					withEventsField_lblDest.DragEnter -= lblDestDragEnter;
				}
				withEventsField_lblDest = value;
				if (withEventsField_lblDest != null) {
					withEventsField_lblDest.DragDrop += lblDestDrop;
					withEventsField_lblDest.DragEnter += lblDestDragEnter;
				}
			}
		}
		private System.Windows.Forms.Button btnChangeSize;
			#endregion
		private System.ComponentModel.IContainer components;

		public void BtnSelectDestClick(object sender, System.EventArgs e)
		{
			openFileDialog1.ShowDialog();
			lblDest.Text = openFileDialog1.FileName;
			showChangeSizeButton();
		}

		public void showChangeSizeButton()
		{
			if (!string.IsNullOrEmpty(txtNewSize.Text) & !string.IsNullOrEmpty(openFileDialog1.FileName)) {
				btnChangeSize.Enabled = true;
			}
		}

		public void BtnCancelClick(object sender, System.EventArgs e)
		{
			if (((processCaller != null))) {
				processCaller.Cancel();
			}
		}

		/// <summary>
		/// Handles the events of StdOutReceived.
		/// </summary>
		/// <remarks>
		/// </remarks>
		private void writeStreamInfo(object sender, Proc.DataReceivedEventArgs e)
		{
			string tmpstr = null;

			if (sender.cancelledFlag | sender.failedFlag) {
				return;
			}

			if (Strings.InStr(e.Text, "Grow:")) {
				if (StatusLabel1.Text != "Working, Please Wait...") {
					StatusLabel1.Text = "Working, Please Wait...";
				}

				tmpstr = Strings.Mid(Strings.LTrim(e.Text), Strings.InStr(Strings.LTrim(e.Text), " ") + 1);
				tmpstr = Strings.Mid(tmpstr, 1, Strings.InStr(tmpstr, "%") - 1);
				ProgressBar1.Value = tmpstr;
			} else {
				StatusLabel1.Text = e.Text;
			}
		}

		/// <summary>
		/// Handles the events of processCompleted & processCanceled
		/// </summary>
		private void processCompletedOrCanceled(object sender, EventArgs e)
		{
			this.Cursor = Cursors.Default;
			this.btnChangeSize.Enabled = true;
			this.btnCancel.Enabled = false;
			this.ProgressBar1.Visible = false;

			if (sender.cancelledflag) {
				StatusLabel1.Text = "User Cancelled";
			} else if (sender.failedFlag) {
				StatusLabel1.Text = "Operation Failed";
			} else if (sender.completeFlag) {
				StatusLabel1.Text = "Operation completed successfully";
			}
		}

		public void BtnExitClick(object sender, System.EventArgs e)
		{
			this.Close();
		}

		public void Me_OnClosing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if (((processCaller != null))) {
				processCaller.Cancel();
			}
		}

		public void LinkLabel1LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			Process.Start("http://www.ebswift.com");
		}

// this is a helper for getting the file/folder for destination
// if the user chooses to drag a folder location it will be used
// in the folder dialog.  If they drag a file it will be used for output.
		public void lblDestDrop(object sender, System.Windows.Forms.DragEventArgs e)
		{
			base.OnDragDrop(e);
			string[] data = e.Data.GetData(DataFormats.FileDrop);
			string s = null;

			foreach (string s_loopVariable in data) {
				s = s_loopVariable;
				// stop on the first valid file/folder found
				lblDest.Text = s;

				openFileDialog1.FileName = s;

				BtnSelectDestClick(null, null);
				break; // TODO: might not be correct. Was : Exit For
			}
		}

		public void lblDestDragEnter(object sender, System.Windows.Forms.DragEventArgs e)
		{
			base.OnDragEnter(e);
			string[] data = e.Data.GetData(DataFormats.FileDrop);
			string s = null;

			foreach (string s_loopVariable in data) {
				s = s_loopVariable;
				// stop on the first valid file/folder found
				e.Effect = DragDropEffects.Copy;
				break; // TODO: might not be correct. Was : Exit For
			}
		}

		public void txtNewSizeTextChanged(object sender, System.EventArgs e)
		{
			showChangeSizeButton();
		}

		public void BtnChangeSizeClick(object sender, System.EventArgs e)
		{
			string toRun = null;

			StatusLabel1.Text = "Changing VMWare Disk Size...";
			ProgressBar1.Visible = true;

			btnCancel.Enabled = true;

			toRun = "J:\\Program Files\\VMware\\VMware Workstation\\vmware-vdiskmanager.exe";

			this.Cursor = Cursors.AppStarting;
			this.btnChangeSize.Enabled = false;

			processCaller = new ProcessCaller(this);
			processCaller.FileName = "" + toRun;
			processCaller.WorkingDirectory = "J:\\Program Files\\VMware\\VMware Workstation\\";
			processCaller.Arguments = "-x " + txtNewSize.Text + "GB " + Strings.chr(34) + lblDest.Text + Strings.chr(34);
			processCaller.StdErrReceived += writeStreamInfo;
			processCaller.StdOutReceived += writeStreamInfo;
			processCaller.Completed += processCompletedOrCanceled;
			processCaller.Cancelled += processCompletedOrCanceled;

			// the following function starts a process and returns immediately,
			// thus allowing the form to stay responsive.
			processCaller.Start();
		}
	}
}
